using System;
using System.Collections.Generic;
using System.IO;
using UnityEngine;
using UnityEngine.Events;

namespace HumanEy
{
    public class HumanEy
    {

        public static void Main()
        {

            //EyeHuman
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Eyed Human -EYE",
                    NameToOrderByOverride = "EyedHuman",
                    DescriptionOverride = "Closes his eyes when he dies.",
                    CategoryOverride = ModAPI.FindCategory("Entities"),
                    ThumbnailOverride = ModAPI.LoadSprite("Eyethumb.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var skin = ModAPI.LoadTexture("skinlayer.png");
                        var flesh = ModAPI.LoadTexture("fleshlayer.png");
                        var bone = ModAPI.LoadTexture("bonelayer.png");
                        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone);

                        //get person
                        var person = Instance.GetComponent<PersonBehaviour>();

                        //change procedural damage colours if they interfere with your texture (rgb 0-255)
                        person.SetBruiseColor(170, 0, 0); //main bruise colour. purple-ish by default
                        person.SetSecondBruiseColor(90, 0, 0); //second bruise colour. red by default
                        person.SetThirdBruiseColor(60, 0, 0); // third bruise colour. light yellow by default
                        person.SetRottenColour(202, 199, 104); // rotten/zombie colour. light yellow/green by default
                        person.SetBloodColour(70, 0, 0); // blood colour. dark red by default. note that this does not change decal nor particle effect colours. it only affects the procedural blood color which may or may not be rendered

                        // Eye code

                        //makes all gameobjects required
                        var head = Instance.transform.GetChild(5);
                        var eye = new GameObject("eye");
                        var eyeOffset = new GameObject("eyeOffset");
                        eyeOffset.transform.SetParent(head);
                        var eyeOffsetTransform = eyeOffset.transform;

                        // Sets eye to the offset so you can actually move the general location of the eye
                        eye.transform.SetParent(eyeOffsetTransform);
                        eye.transform.localPosition = new Vector3(0f, 0f); // doesnt work (this is why i made the eye offset)
                        eye.transform.rotation = Quaternion.Euler(0f, 0f, 0f); //doesnt work (this is why i made the eye offset)
                        eye.transform.localScale = new Vector3(1f, 1f); //doesnt work (this is why i made the eye offset)


                        // Change these to change stuff about the eye
                        eyeOffset.transform.localScale = new Vector3(1f, 1f);
                        eyeOffset.transform.localPosition = new Vector3(0.08f, 0.04f);
                        eyeOffset.transform.rotation = Quaternion.Euler(0f, 0f, 0f);

                        // Sets the sprite of the eye
                        var eyesprite = eye.AddComponent<SpriteRenderer>();
                        eyesprite.sprite = ModAPI.LoadSprite("HumanEye.png");  // change this to whatever to have a custom eye texture
                        eyesprite.sortingLayerName = "Top";

                        // adds the eye behaviour already in the assembly
                        var eyeBehaviour = eye.AddComponent<GorseEyeBehaviour>();

                        // gets the head limb behaviour so the eye can disapear when the human is unconcious or dead
                        var headLimbBehaviour = head.GetComponent<LimbBehaviour>();

                        // edits the eye behaviour so it works
                        eyeBehaviour.Limb = headLimbBehaviour;
                        eyeBehaviour.Renderer = eyesprite;
                        eyeBehaviour.LargeRange = new Vector2(0.01f, 0.01f);
                        eyeBehaviour.SmallRange = new Vector2(5.01f, 5.01f);



                    }
                }
            );

            //EyeClotheHuman
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Clothed Human -EYE",
                    NameToOrderByOverride = "ClothingHumanEYE",
                    DescriptionOverride = "Closes his eyes when he dies, atleast he's not exposed.",
                    CategoryOverride = ModAPI.FindCategory("Entities"),
                    ThumbnailOverride = ModAPI.LoadSprite("Eyeclothethumb.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var skin = ModAPI.LoadTexture("clothedman.png");
                        var flesh = ModAPI.LoadTexture("fleshlayer.png");
                        var bone = ModAPI.LoadTexture("bonelayer.png");
                        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone);

                        //get person
                        var person = Instance.GetComponent<PersonBehaviour>();

                        //change procedural damage colours if they interfere with your texture (rgb 0-255)
                        person.SetBruiseColor(170, 0, 0); //main bruise colour. purple-ish by default
                        person.SetSecondBruiseColor(90, 0, 0); //second bruise colour. red by default
                        person.SetThirdBruiseColor(60, 0, 0); // third bruise colour. light yellow by default
                        person.SetRottenColour(202, 199, 104); // rotten/zombie colour. light yellow/green by default
                        person.SetBloodColour(70, 0, 0); // blood colour. dark red by default. note that this does not change decal nor particle effect colours. it only affects the procedural blood color which may or may not be rendered

                        // Eye code

                        //makes all gameobjects required
                        var head = Instance.transform.GetChild(5);
                        var eye = new GameObject("eye");
                        var eyeOffset = new GameObject("eyeOffset");
                        eyeOffset.transform.SetParent(head);
                        var eyeOffsetTransform = eyeOffset.transform;

                        // Sets eye to the offset so you can actually move the general location of the eye
                        eye.transform.SetParent(eyeOffsetTransform);
                        eye.transform.localPosition = new Vector3(0f, 0f); // doesnt work (this is why i made the eye offset)
                        eye.transform.rotation = Quaternion.Euler(0f, 0f, 0f); //doesnt work (this is why i made the eye offset)
                        eye.transform.localScale = new Vector3(1f, 1f); //doesnt work (this is why i made the eye offset)


                        // Change these to change stuff about the eye
                        eyeOffset.transform.localScale = new Vector3(1f, 1f);
                        eyeOffset.transform.localPosition = new Vector3(0.08f, 0.04f);
                        eyeOffset.transform.rotation = Quaternion.Euler(0f, 0f, 0f);

                        // Sets the sprite of the eye
                        var eyesprite = eye.AddComponent<SpriteRenderer>();
                        eyesprite.sprite = ModAPI.LoadSprite("HumanEye.png");  // change this to whatever to have a custom eye texture
                        eyesprite.sortingLayerName = "Top";

                        // adds the eye behaviour already in the assembly
                        var eyeBehaviour = eye.AddComponent<GorseEyeBehaviour>();

                        // gets the head limb behaviour so the eye can disapear when the human is unconcious or dead
                        var headLimbBehaviour = head.GetComponent<LimbBehaviour>();

                        // edits the eye behaviour so it works
                        eyeBehaviour.Limb = headLimbBehaviour;
                        eyeBehaviour.Renderer = eyesprite;
                        eyeBehaviour.LargeRange = new Vector2(0.01f, 0.01f);
                        eyeBehaviour.SmallRange = new Vector2(5.01f, 5.01f);



                    }
                }
            );

            //Soldier EyeHuman
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Military-Soldier -EYE",
                    NameToOrderByOverride = "Military-Soldier EyedHuman",
                    DescriptionOverride = "Closes his eyes when he dies, Oo-rah!-style.",
                    CategoryOverride = ModAPI.FindCategory("Entities"),
                    ThumbnailOverride = ModAPI.LoadSprite("Eyesoldierthumb.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var skin = ModAPI.LoadTexture("soldierskin.png");
                        var flesh = ModAPI.LoadTexture("fleshlayer.png");
                        var bone = ModAPI.LoadTexture("bonelayer.png");
                        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone);

                        //get person
                        var person = Instance.GetComponent<PersonBehaviour>();

                        //change procedural damage colours if they interfere with your texture (rgb 0-255)
                        person.SetBruiseColor(170, 0, 0); //main bruise colour. purple-ish by default
                        person.SetSecondBruiseColor(90, 0, 0); //second bruise colour. red by default
                        person.SetThirdBruiseColor(60, 0, 0); // third bruise colour. light yellow by default
                        person.SetRottenColour(202, 199, 104); // rotten/zombie colour. light yellow/green by default
                        person.SetBloodColour(70, 0, 0); // blood colour. dark red by default. note that this does not change decal nor particle effect colours. it only affects the procedural blood color which may or may not be rendered

                        // Eye code

                        //makes all gameobjects required
                        var head = Instance.transform.GetChild(5);
                        var eye = new GameObject("eye");
                        var eyeOffset = new GameObject("eyeOffset");
                        eyeOffset.transform.SetParent(head);
                        var eyeOffsetTransform = eyeOffset.transform;

                        // Sets eye to the offset so you can actually move the general location of the eye
                        eye.transform.SetParent(eyeOffsetTransform);
                        eye.transform.localPosition = new Vector3(0f, 0f); // doesnt work (this is why i made the eye offset)
                        eye.transform.rotation = Quaternion.Euler(0f, 0f, 0f); //doesnt work (this is why i made the eye offset)
                        eye.transform.localScale = new Vector3(1f, 1f); //doesnt work (this is why i made the eye offset)


                        // Change these to change stuff about the eye
                        eyeOffset.transform.localScale = new Vector3(1f, 1f);
                        eyeOffset.transform.localPosition = new Vector3(0.08f, 0.04f);
                        eyeOffset.transform.rotation = Quaternion.Euler(0f, 0f, 0f);

                        // Sets the sprite of the eye
                        var eyesprite = eye.AddComponent<SpriteRenderer>();
                        eyesprite.sprite = ModAPI.LoadSprite("HumanEye.png");  // change this to whatever to have a custom eye texture
                        eyesprite.sortingLayerName = "Top";

                        // adds the eye behaviour already in the assembly
                        var eyeBehaviour = eye.AddComponent<GorseEyeBehaviour>();

                        // gets the head limb behaviour so the eye can disapear when the human is unconcious or dead
                        var headLimbBehaviour = head.GetComponent<LimbBehaviour>();

                        // edits the eye behaviour so it works
                        eyeBehaviour.Limb = headLimbBehaviour;
                        eyeBehaviour.Renderer = eyesprite;
                        eyeBehaviour.LargeRange = new Vector2(0.01f, 0.01f);
                        eyeBehaviour.SmallRange = new Vector2(5.01f, 5.01f);



                    }
                }
            );

            //Terror EyeHuman
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Runic Terrorist -EYE",
                    NameToOrderByOverride = "Rune-Terrorist EyedHuman",
                    DescriptionOverride = "How nice of these goons to have a proper uniform.",
                    CategoryOverride = ModAPI.FindCategory("Entities"),
                    ThumbnailOverride = ModAPI.LoadSprite("Eyeterrorthumb.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var skin = ModAPI.LoadTexture("terrorskin.png");
                        var flesh = ModAPI.LoadTexture("fleshlayer.png");
                        var bone = ModAPI.LoadTexture("bonelayer.png");
                        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone);

                        //get person
                        var person = Instance.GetComponent<PersonBehaviour>();

                        //change procedural damage colours if they interfere with your texture (rgb 0-255)
                        person.SetBruiseColor(170, 0, 0); //main bruise colour. purple-ish by default
                        person.SetSecondBruiseColor(90, 0, 0); //second bruise colour. red by default
                        person.SetThirdBruiseColor(60, 0, 0); // third bruise colour. light yellow by default
                        person.SetRottenColour(202, 199, 104); // rotten/zombie colour. light yellow/green by default
                        person.SetBloodColour(70, 0, 0); // blood colour. dark red by default. note that this does not change decal nor particle effect colours. it only affects the procedural blood color which may or may not be rendered

                        // Eye code

                        //makes all gameobjects required
                        var head = Instance.transform.GetChild(5);
                        var eye = new GameObject("eye");
                        var eyeOffset = new GameObject("eyeOffset");
                        eyeOffset.transform.SetParent(head);
                        var eyeOffsetTransform = eyeOffset.transform;

                        // Sets eye to the offset so you can actually move the general location of the eye
                        eye.transform.SetParent(eyeOffsetTransform);
                        eye.transform.localPosition = new Vector3(0f, 0f); // doesnt work (this is why i made the eye offset)
                        eye.transform.rotation = Quaternion.Euler(0f, 0f, 0f); //doesnt work (this is why i made the eye offset)
                        eye.transform.localScale = new Vector3(1f, 1f); //doesnt work (this is why i made the eye offset)


                        // Change these to change stuff about the eye
                        eyeOffset.transform.localScale = new Vector3(1f, 1f);
                        eyeOffset.transform.localPosition = new Vector3(0.08f, 0.04f);
                        eyeOffset.transform.rotation = Quaternion.Euler(0f, 0f, 0f);

                        // Sets the sprite of the eye
                        var eyesprite = eye.AddComponent<SpriteRenderer>();
                        eyesprite.sprite = ModAPI.LoadSprite("HumanEye.png");  // change this to whatever to have a custom eye texture
                        eyesprite.sortingLayerName = "Top";

                        // adds the eye behaviour already in the assembly
                        var eyeBehaviour = eye.AddComponent<GorseEyeBehaviour>();

                        // gets the head limb behaviour so the eye can disapear when the human is unconcious or dead
                        var headLimbBehaviour = head.GetComponent<LimbBehaviour>();

                        // edits the eye behaviour so it works
                        eyeBehaviour.Limb = headLimbBehaviour;
                        eyeBehaviour.Renderer = eyesprite;
                        eyeBehaviour.LargeRange = new Vector2(0.01f, 0.01f);
                        eyeBehaviour.SmallRange = new Vector2(5.01f, 5.01f);



                    }
                }
            );

            //Counter Terror EyeHuman
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Blueshirt Guardsman -EYE",
                    NameToOrderByOverride = "Counter-Terrorist EyedHuman",
                    DescriptionOverride = "Terrorism countered.",
                    CategoryOverride = ModAPI.FindCategory("Entities"),
                    ThumbnailOverride = ModAPI.LoadSprite("Eyeswatthumb.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var skin = ModAPI.LoadTexture("swatskin.png");
                        var flesh = ModAPI.LoadTexture("fleshlayer.png");
                        var bone = ModAPI.LoadTexture("bonelayer.png");
                        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone);

                        //get person
                        var person = Instance.GetComponent<PersonBehaviour>();

                        //change procedural damage colours if they interfere with your texture (rgb 0-255)
                        person.SetBruiseColor(170, 0, 0); //main bruise colour. purple-ish by default
                        person.SetSecondBruiseColor(90, 0, 0); //second bruise colour. red by default
                        person.SetThirdBruiseColor(60, 0, 0); // third bruise colour. light yellow by default
                        person.SetRottenColour(202, 199, 104); // rotten/zombie colour. light yellow/green by default
                        person.SetBloodColour(70, 0, 0); // blood colour. dark red by default. note that this does not change decal nor particle effect colours. it only affects the procedural blood color which may or may not be rendered

                        // Eye code

                        //makes all gameobjects required
                        var head = Instance.transform.GetChild(5);
                        var eye = new GameObject("eye");
                        var eyeOffset = new GameObject("eyeOffset");
                        eyeOffset.transform.SetParent(head);
                        var eyeOffsetTransform = eyeOffset.transform;

                        // Sets eye to the offset so you can actually move the general location of the eye
                        eye.transform.SetParent(eyeOffsetTransform);
                        eye.transform.localPosition = new Vector3(0f, 0f); // doesnt work (this is why i made the eye offset)
                        eye.transform.rotation = Quaternion.Euler(0f, 0f, 0f); //doesnt work (this is why i made the eye offset)
                        eye.transform.localScale = new Vector3(1f, 1f); //doesnt work (this is why i made the eye offset)


                        // Change these to change stuff about the eye
                        eyeOffset.transform.localScale = new Vector3(1f, 1f);
                        eyeOffset.transform.localPosition = new Vector3(0.08f, 0.04f);
                        eyeOffset.transform.rotation = Quaternion.Euler(0f, 0f, 0f);

                        // Sets the sprite of the eye
                        var eyesprite = eye.AddComponent<SpriteRenderer>();
                        eyesprite.sprite = ModAPI.LoadSprite("HumanEye.png");  // change this to whatever to have a custom eye texture
                        eyesprite.sortingLayerName = "Top";

                        // adds the eye behaviour already in the assembly
                        var eyeBehaviour = eye.AddComponent<GorseEyeBehaviour>();

                        // gets the head limb behaviour so the eye can disapear when the human is unconcious or dead
                        var headLimbBehaviour = head.GetComponent<LimbBehaviour>();

                        // edits the eye behaviour so it works
                        eyeBehaviour.Limb = headLimbBehaviour;
                        eyeBehaviour.Renderer = eyesprite;
                        eyeBehaviour.LargeRange = new Vector2(0.01f, 0.01f);
                        eyeBehaviour.SmallRange = new Vector2(5.01f, 5.01f);



                    }
                }
            );

            //Sand Soldier EyeHuman
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Sand-Soldier -EYE",
                    NameToOrderByOverride = "Sand-Soldier EyedHuman",
                    DescriptionOverride = "Closes his eyes when he dies, Urrah!-style.",
                    CategoryOverride = ModAPI.FindCategory("Entities"),
                    ThumbnailOverride = ModAPI.LoadSprite("Eyessoldierthumb.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var skin = ModAPI.LoadTexture("ssoldierskin.png");
                        var flesh = ModAPI.LoadTexture("fleshlayer.png");
                        var bone = ModAPI.LoadTexture("bonelayer.png");
                        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone);

                        //get person
                        var person = Instance.GetComponent<PersonBehaviour>();

                        //change procedural damage colours if they interfere with your texture (rgb 0-255)
                        person.SetBruiseColor(170, 0, 0); //main bruise colour. purple-ish by default
                        person.SetSecondBruiseColor(90, 0, 0); //second bruise colour. red by default
                        person.SetThirdBruiseColor(60, 0, 0); // third bruise colour. light yellow by default
                        person.SetRottenColour(202, 199, 104); // rotten/zombie colour. light yellow/green by default
                        person.SetBloodColour(70, 0, 0); // blood colour. dark red by default. note that this does not change decal nor particle effect colours. it only affects the procedural blood color which may or may not be rendered

                        // Eye code

                        //makes all gameobjects required
                        var head = Instance.transform.GetChild(5);
                        var eye = new GameObject("eye");
                        var eyeOffset = new GameObject("eyeOffset");
                        eyeOffset.transform.SetParent(head);
                        var eyeOffsetTransform = eyeOffset.transform;

                        // Sets eye to the offset so you can actually move the general location of the eye
                        eye.transform.SetParent(eyeOffsetTransform);
                        eye.transform.localPosition = new Vector3(0f, 0f); // doesnt work (this is why i made the eye offset)
                        eye.transform.rotation = Quaternion.Euler(0f, 0f, 0f); //doesnt work (this is why i made the eye offset)
                        eye.transform.localScale = new Vector3(1f, 1f); //doesnt work (this is why i made the eye offset)


                        // Change these to change stuff about the eye
                        eyeOffset.transform.localScale = new Vector3(1f, 1f);
                        eyeOffset.transform.localPosition = new Vector3(0.08f, 0.04f);
                        eyeOffset.transform.rotation = Quaternion.Euler(0f, 0f, 0f);

                        // Sets the sprite of the eye
                        var eyesprite = eye.AddComponent<SpriteRenderer>();
                        eyesprite.sprite = ModAPI.LoadSprite("HumanEye.png");  // change this to whatever to have a custom eye texture
                        eyesprite.sortingLayerName = "Top";

                        // adds the eye behaviour already in the assembly
                        var eyeBehaviour = eye.AddComponent<GorseEyeBehaviour>();

                        // gets the head limb behaviour so the eye can disapear when the human is unconcious or dead
                        var headLimbBehaviour = head.GetComponent<LimbBehaviour>();

                        // edits the eye behaviour so it works
                        eyeBehaviour.Limb = headLimbBehaviour;
                        eyeBehaviour.Renderer = eyesprite;
                        eyeBehaviour.LargeRange = new Vector2(0.01f, 0.01f);
                        eyeBehaviour.SmallRange = new Vector2(5.01f, 5.01f);



                    }
                }
            );

            //Fleshman
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Fleshman -EYE",
                    NameToOrderByOverride = "Fleshman",
                    DescriptionOverride = "Goopy..",
                    CategoryOverride = ModAPI.FindCategory("Entities"),
                    ThumbnailOverride = ModAPI.LoadSprite("fleshthumb.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var skin = ModAPI.LoadTexture("fleshlayer.png");
                        var flesh = ModAPI.LoadTexture("fleshbonelayer.png");
                        var bone = ModAPI.LoadTexture("nolayer.png");
                        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone);

                        //get person
                        var person = Instance.GetComponent<PersonBehaviour>();

                        //change procedural damage colours if they interfere with your texture (rgb 0-255)
                        person.SetBruiseColor(170, 0, 0); //main bruise colour. purple-ish by default
                        person.SetSecondBruiseColor(90, 0, 0); //second bruise colour. red by default
                        person.SetThirdBruiseColor(60, 0, 0); // third bruise colour. light yellow by default
                        person.SetRottenColour(202, 199, 104); // rotten/zombie colour. light yellow/green by default
                        person.SetBloodColour(70, 0, 0); // blood colour. dark red by default. note that this does not change decal nor particle effect colours. it only affects the procedural blood color which may or may not be rendered

                    }
                }
            );


        }
    }
}